#!/usr/bin/env python3
# -*- coding: utf-8 -*-

import os
import sys, tty, termios, time
import wnfwecker_const as C
import wnfwecker_tools as T
import wnfwecker_moc as M
import wnfwecker_ini

ini = wnfwecker_ini.iniObject()


def _getKommando():
    fd = sys.stdin.fileno()
    old_settings = termios.tcgetattr(fd)
    try:
        tty.setraw(sys.stdin.fileno())
        ch = sys.stdin.read(1)
    finally:
        termios.tcsetattr(fd, termios.TCSADRAIN, old_settings)
    return ch

def _make_executable(path):
    if os._exists(path):
        mode = os.stat(path).st_mode
        mode |= (mode & 0o444) >> 2  # copy R bits to X
        os.chmod(path, mode)

kommando_system = [
    {'key': '1', 'cmd':'sudo nano /etc/systemd/system/wnfwecker_http.service'},
    {'key': '2', 'cmd':'sudo nano /etc/wpa_supplicant/wpa_supplicant.conf'},
    ]

kommando0 = [
    {'key': 'h', 'cmd': 'Diese Hilfeseite'},
    {'key': 'q', 'cmd': 'Quit'},
    {'key': '1', 'cmd': 'sudo service wnfwecker_http restart'},
    {'key': '2', 'cmd': 'sudo service wnfwecker_raspi restart'},
    {'key': '3', 'cmd': 'tail -40 wnfwecker.log'},
    {'key': '4', 'cmd': 'tail -40 /var/log/syslog'},
    {'key': '5', 'cmd': './wnfwecker_http.py'},
    {'key': '6', 'cmd': 'curl 127.0.0.1:%s' % (T.iniGetBottlePort())},
    {'key': 's', 'cmd': 'Soundcheck'},
    {'key': 'n', 'cmd': 'nano %s' % (ini.IniDateiname)},
]


def hpKopf0():
    print("=" * 80)
    print('HerdePower für %s.%s (aktualisiert um %s)' % (
    C.PROGNAME, C.PROGBUILD, (time.strftime("%d.%m.%Y %H:%M:%S"))))
    print(os.getcwd())
    print("Hostname %s" % T.getHostname())
    print("Default Gateway %s" % T.getDefaultGateWay())
    print("-" * 80)
    for k in kommando0:
        print('%s - %s' % (k['key'], k['cmd']))
    print("=" * 80)


def hpShell(cmd):
    print("=" * 80)
    print(cmd)
    os.system(cmd)
    print("=" * 80)


def soundCheck():
    M.fanfare()


def hpSchleife0():
    while True:
        ch = _getKommando()
        if (ch == 'q'):
            break
        elif (ch == 'h'):
            hpKopf0()
        elif (ch == 's'):
            soundCheck()
        else:
            for k in kommando0:
                if (ch == k['key']):
                    hpShell(k['cmd'])


def main():
    T._info('Power für %s.%s gestartet.' % (C.PROGNAME, C.PROGBUILD))
    # _make_executable(_getKommandoZ())
    hpKopf0()
    hpSchleife0()
    T._info('Power für %s.%s beendet.' % (C.PROGNAME, C.PROGBUILD))


if __name__ == '__main__':
    main()
