#!/usr/bin/env python3
# -*- coding: utf-8 -*-
#

# Literatur
# MOC - music on console
# http://moc.daper.net 

import os
import inspect
import time
import subprocess
import urllib.request
from glob import glob
import wnfwecker_ini
import wnfwecker_tools as T
import random
import bg_helper as bh

ini = wnfwecker_ini.iniObject()
verzeichnis = os.path.dirname(os.path.abspath(inspect.getfile(inspect.currentframe())))
cFanfareOgg = "%s/wnfwecker_positive.ogg" % verzeichnis
cIsOkOgg = "%s/Oxygen-Im-Phone-Ring.ogg" % verzeichnis
cMocPid = "%s/.moc/pid" % (os.environ["HOME"])


def wartenAufNetz(logFile):
    # print(aSender)
    aSender = ''
    i = 0
    while i < 5:
        try:
            ini.refreshWennNoetig(logFile)
            aSender = ini.radioSender_1()
            response = urllib.request.urlopen(aSender)
            if response.getcode() == 200:
                return True
            time.sleep(10)
            i = i + 1
            print('Warten auf Netz %s %s' % (i, aSender))
        except:
            time.sleep(10)
            i = i + 1
            print('Warten auf Netz %s %s' % (i, aSender))
    return False


def initPlay(logFile):
    ini.refreshWennNoetig(logFile)
    time.sleep(1)
    # moc Server-starten
    s = "mocp -S"
    os.system(s)
    # print cMocPid
    ok = T.wnfFileExists(cMocPid)
    if ok:
        ok = (initPlaylist(logFile) != '')
    return ok


def donePlay():
    s = "mocp --exit"
    os.system(s)
    return False


def initPlaylist(logFile):
    # Löschen der Playlist
    s = "mocp -c"
    os.system(s)

    ini.refreshWennNoetig(logFile)

    if ini.isOnline():
        wartenAufNetz(logFile)
        aSender = ini.radioSender_1()
        # print(aSender)
        try:
            response = urllib.request.urlopen(aSender)
            if response.getcode() == 200:
                filename, file_extension = os.path.splitext(aSender)
                if (file_extension == '.m3u'):
                    aDateiname = '/tmp/einslive.m3u'
                    T.wnfFileDelete(aDateiname)
                    s = 'wget %s -O %s -q' % (aSender, aDateiname)
                    os.system(s)
                    b = T.wnfFileExistsAndNZ(aDateiname)
                    if not b:
                        print("Keine Verbindung zum Internet")
                        aDateiname = '/tmp/wnfwecker/'
                        erstelleTemplist(ini.musikDir_1(), aDateiname)
                elif (file_extension == '.mp3'):
                    aDateiname = aSender
            else:
                print("Keine Verbindung zum Internet")
                aDateiname = '/tmp/wnfwecker/'
                erstelleTemplist(ini.musikDir_1(), aDateiname)
        except:
            print("Keine Verbindung zum Internet")
            aDateiname = '/tmp/wnfwecker/'
            erstelleTemplist(ini.musikDir_1(), aDateiname)
    else:
        print("Offlinemodus")
        aDateiname = '/tmp/wnfwecker/'
        erstelleTemplist(ini.musikDir_1(), aDateiname)

    # Anhängen an die Playlist
    print(aDateiname)
    s = "mocp -a %s" % (aDateiname)
    os.system(s)
    return aDateiname


def allMp3s(aAusOrdner):
    print(aAusOrdner)
    result = [y for x in os.walk(aAusOrdner) for y in glob(os.path.join(x[0], '**/*.mp3'))]
    return result


def erstellePlaylist(aAusOrdner, aM3UDateiname):
    alle = allMp3s(aAusOrdner)
    f = open(aM3UDateiname, 'w')
    anz = 0
    while anz < 100:
        dn = random.choice(alle)
        f.write("%s\n" % dn)
        anz = anz + 1
    f.close()


def erstelleTemplist(aAusOrdner, aTempVerzeichnis):
    alle = allMp3s(aAusOrdner)
    T.wnfForceDirectories(aTempVerzeichnis)
    # TempVerzeichnis leeren
    T.wnfClearDirectory(aTempVerzeichnis)
    # Tempverzeichnis füllen
    anz = 0
    while anz < 100:
        dn = random.choice(alle)
        zn = "%sTitel_%04d.mp3" % (aTempVerzeichnis, anz)
        # Erzeuge im TempVerzeichnis Link zur Zieldatei
        s = "ln -s %s %s" % (T.shellquote(dn), T.shellquote(zn))
        # print(s)
        os.system(s)
        anz = anz + 1


def mocInfoDict():
    output = bh.run_output('mocp --info', timeout=2)
    return dict([
        (k.lower(), v.strip())
        for k, v in [
            line.split(':', 1)
            for line in output.split('\n')
            if line
        ]
    ])


def getTitel():
    try:
        d = mocInfoDict()
        print(d)
        s = d['songtitle']
        print(s)
        return s
    except:
        return ''
    # Anzeigen welcher Titel gespielt wird
    # s = "mocp -i"
    s = "mocp -i | grep SongTitle"
    # os.system(s)
    process = subprocess.Popen([s], shell=True, stdout=subprocess.PIPE)
    b = process.stdout.read()
    s = b.decode()
    s = s.replace("SongTitle: ", '')
    return s


def getVolumeMaxProzent(logFile):
    ini.refreshWennNoetig(logFile)
    return int(ini.volumeMaxProzent())


def anzeigeTitel():
    # Anzeigen welcher Titel gespielt wird
    s = "mocp -i"
    os.system(s)


def startPlay(aberLangsam, logFile):
    ini.refreshWennNoetig(logFile)
    # Lautstärke auf Null
    s = "amixer sset '%s' 0%%" % (ini.volumeControl())
    os.system(s)
    s = "mocp --play --info"
    os.system(s)
    time.sleep(1)
    v = 0
    for i in range(10):
        v = v + int(ini.volumeStep())
        s = "amixer sset '%s' %s%%" % (ini.volumeControl(), v)
        # print(s)
        os.system(s)
        if aberLangsam:
            time.sleep(1)
    return True


def volumeProzent(aProzent, logFile):
    ini.refreshWennNoetig(logFile)
    aMax = int(ini.volumeMaxProzent())
    if (int(aProzent) < aMax):
        s = "amixer -q sset '%s' %s%%" % (ini.volumeControl(), aProzent)
        # print(s)
    else:
        s = "amixer -q sset '%s' %s%%" % (ini.volumeControl(), aMax)
        # print(s)
    os.system(s)
    return True


def volumeLauter(logFile):
    ini.refreshWennNoetig(logFile)
    s = "amixer -q sset '%s' %s%%+" % (ini.volumeControl(), ini.volumeStep())
    # print(s)
    os.system(s)
    return True


def volumeLeiser(logFile):
    ini.refreshWennNoetig(logFile)
    s = "amixer -q sset '%s' %s%%-" % (ini.volumeControl(), ini.volumeStep())
    # print(s)
    os.system(s)
    return True


def startPlayVolumeNull():
    s = "amixer -q sset '%s' 0%%" % (ini.volumeControl())
    # print(s)
    os.system(s)
    # print(s)
    s = "mocp --play"
    os.system(s)
    return True


def stopPlay():
    # s="mocp --clear --stop"
    s = "mocp --stop"
    os.system(s)
    return False


def testStartStop():
    try:
        ok = initPlay()
        aMusikSpielt = False
        aLautstaerke = 0
        if ok:
            aMusikSpielt = startPlayVolumeNull()
            while aMusikSpielt:
                if aLautstaerke <= 10:
                    volumeProzent(aLautstaerke * 10)
                    aLautstaerke = aLautstaerke + 1
                aMusikSpielt = aLautstaerke <= 10
                time.sleep(1)
            aMusikSpielt = True
            aRestZeit = 0
            # anzeigeTitel()
            while aMusikSpielt:
                aRestZeit = aRestZeit + 1
                aMusikSpielt = aRestZeit <= 10
                time.sleep(1)
            stopPlay()

        time.sleep(1)

        donePlay()
        return

        aMusikSpielt = False
        aLautstaerke = 0
        if ok:
            aMusikSpielt = startPlayVolumeNull()
            while aMusikSpielt:
                if aLautstaerke <= 10:
                    volumeProzent(aLautstaerke * 10)
                    aLautstaerke = aLautstaerke + 1
                aMusikSpielt = aLautstaerke <= 10
                time.sleep(1)
            aMusikSpielt = True
            aRestZeit = 0
            # anzeigeTitel()
            while aMusikSpielt:
                aRestZeit = aRestZeit + 1
                aMusikSpielt = aRestZeit <= 1000
                time.sleep(1)
            stopPlay()
    finally:
        donePlay()


def fanfare():
    T._info(cFanfareOgg)
    bh.run_output('mocp -S')
    bh.run_output("mocp --clear --stop")
    bh.run_output("mocp -a %s" % (cFanfareOgg))
    # i = int(ini.volumeStep()) * 10
    # bh.run_output("amixer sset '%s' %s%%" % (ini.volumeControl(), i))
    bh.run_output("mocp --play")
    time.sleep(1)
    stopPlay()


def playogg(aOgg):
    T._info(aOgg)
    bh.run_output("ogg123 %s" % (aOgg))
    return
    bh.run_output('mocp -S')
    bh.run_output("mocp --clear --stop")
    bh.run_output("mocp -a %s" % (aOgg))
    bh.run_output("mocp --play")
    time.sleep(1)
    stopPlay()


def playIsOk():
    playogg(cIsOkOgg)


def main():
    fanfare()
    # initPlay(None)
    # donePlay()
    # testStartStop()
    return 0


if __name__ == '__main__':
    main()
