#! /usr/bin/python3
# -*- coding: utf-8 -*-

import logging
import datetime, time
import wnfwecker_moc as R
import wnfwecker_weckzeit as W
import wnfwecker_tools as T
import wnfwecker_ini

ini = wnfwecker_ini.iniObject()

cAnzeigeUhr_0 = 0
cAnzeigeStatus_1 = 1

cAnzeigeFarbe_Tag_1 = 1
cAnzeigeFarbe_Nacht_2 = 2
cAnzeigeFarbe_Alarm_31 = 31
cAnzeigeFarbe_Alarm_32 = 32
cAnzeigeFarbe_Snooze_4 = 4

def _info(s):
    T._info(s)

def consoleClock():
    aMusikSpielt = False
    _info('Programm ist gestartet.')
    dt = datetime.datetime.today()
    if not W.isWeckZeit(dt, T.logFile):
        _info('Soundcheck 300s gestartet.')
        if (not aMusikSpielt):
            R.initPlay(T.logFile)
            aMusikSpielt = R.startPlayVolumeNull()
            aLautstaerke = 0
            if aMusikSpielt:
                aSekunden = 0
                R.volumeProzent(100,T.logFile)
                # R.anzeigeTitel()
                while (aSekunden < 300):
                    time.sleep(1)
                    aSekunden += 1
                    print(aSekunden, end='\r')
                R.stopPlay()
        _info('Soundcheck beendet.')
        time.sleep(10)
    aMusikSpielt = False
    aLautstaerke = 0
    while W.isEingeschaltet(T.logFile):
        dt = datetime.datetime.today()
        if W.isWeckZeit(dt, T.logFile):
            if (not aMusikSpielt):
                _info("wecken %s " % dt.strftime("%d.%m.%Y %H:%M"))
                R.initPlay(T.logFile)
                aMusikSpielt = R.startPlayVolumeNull()
                aLautstaerke = 0
                _info('R.startPlayVolumeNull()')
        else:
            # print "nicht wecken",dt.strftime("%d.%m.%Y %H:%M")
            if (aMusikSpielt):
                aMusikSpielt = R.stopPlay()
                _info('R.stopPlay()')
                #_info('initPlay')
                #R.initPlay(logFile)
        if aMusikSpielt:
            if aLautstaerke <= 10:
                R.volumeProzent(aLautstaerke * 10,T.logFile)
                _info('R.volumeProzent(%d)' % (aLautstaerke * 10))
                aLautstaerke = aLautstaerke + 1
            else:
                R.volumeProzent(100,T.logFile)
                # _debug('R.volumeProzent(100)')
                # R.anzeigeTitel()
        time.sleep(1)

    # Alle verwendeten Geräte ausschalten
    if (aMusikSpielt):
        aMusikSpielt = R.stopPlay()
        _info('R.stopPlay()')
    _info("wnfWecker ist in der Ini-Datei ausgeschaltet.")


def main():
    consoleClock()


if __name__ == '__main__':
    try:
        main()
    finally:
        R.donePlay()
        logging.shutdown()
