#!/usr/bin/env python
# -*- coding: utf-8 -*-
#
import cherrypy
import json
import datetime
import wnfwecker_ini
import wnfwecker_moc as R


class object_q(object):
    
    def __init__(self):
        self.ini = wnfwecker_ini.iniObject()

    def is_angemeldet(self):
        return True
        
    @cherrypy.expose
    def wnfwecker_status(self):
        if self.is_angemeldet():
            j = {'version':1000,
            'status':[
               {'bb_bundesland':self.ini.bundesland()},
               {'bb_weckvolume':self.ini.volumeMaxProzent()}
               ],
            'weckzeiten':[
               {'mo':self.ini.weckZeit('Montag')},
               {'di':self.ini.weckZeit('Dienstag')},
               {'mi':self.ini.weckZeit('Mittwoch')},
               {'do':self.ini.weckZeit('Donnerstag')},
               {'fr':self.ini.weckZeit('Freitag')},
               {'sa':self.ini.weckZeit('Samstag')},
               {'so':self.ini.weckZeit('Sonntag')},
               {'ft':self.ini.weckZeit('Feiertag')}
               ]
            }
            return json.dumps(j)
        else:
            return json.dumps({})

    @cherrypy.expose
    def musikein(self):
        if self.is_angemeldet():
            R.initPlay()
            R.startPlayVolumeNull()
            R.volumeProzent(self.ini.volumeMaxProzent())
            return json.dumps({})
        else:
            return json.dumps({})

    @cherrypy.expose
    def musikaus(self):
        if self.is_angemeldet():
            R.stopPlay()
            #R.donePlay()
            return json.dumps({})
        else:
            return json.dumps({})

    @cherrypy.expose
    def musikvolume(self,aVolumeProzent):
        if self.is_angemeldet():
            #R.initPlay()
            R.volumeProzent(aVolumeProzent)
            #print aVolumeProzent
            return json.dumps({})
        else:
            return json.dumps({})
